#!/usr/bin/perl

print "\n\tusage: $0 < file_list\n\n";
my @files = <STDIN>;
chomp (@files);
my $max_file_len = max(@files) + 1;

my %regexps = (
	       Apache          => '[^:]Apache',
	       Tdf             => '[^:]Tdf',
	       User            => '[^:]User[^c]',
	       Userconfig      => '[^:]Userconfig',
	       Sql             => '[^:]Sql[^:]',
	       'Sql::Oracle'   => '[^:]Sql::Oracle',
	       Adder           => '[^:]Adder[^:]',
	       Launder         => '[^:]Launder',
	       'Launder::NotH' => '[^:]Launder::NotH',
);

my %file;
print join("\t", "File" . ' 'x($max_file_len - 5), sort(keys(%regexps))), "\n", '-'x100, "\n";
foreach $file (@files) {
    print "$file" . ' 'x($max_file_len - length($file));
    foreach my $key (sort(keys(%regexps))) {
	my $regexp = $regexps{$key};
	chomp($num = `egrep '$regexp' $file | wc -l`);
	$num =~ s/\s+//;
	print "$num" . ' 'x(length($key)-length($num)) . "\t";
    }
    print "\n";
}

sub max {
    my ($max) = sort {length($b) cmp length($a)}  @_;
    return length($max);
}
